//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  Orange
#property indicator_color2  LimeGreen

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame        = PERIOD_CURRENT;
extern int             Risk             = 6;
extern bool            alertsOn         = false;
extern bool            alertsOnCurrent  = true;
extern bool            alertsMessage    = true;
extern bool            alertsSound      = false;
extern bool            alertsEmail      = false;
extern bool            alertsNotify     = false;
extern double          ArrowsGap        = 1.0;
extern bool            ArrowsOnFirstBar = true;

double arrDn[];
double arrUp[];
double wpr[];

string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,arrDn); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,234);
   SetIndexBuffer(1,arrUp); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,233);
   SetIndexBuffer(2,wpr);
   
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame==-99;
   TimeFrame         = MathMax(TimeFrame,_Period);
   
return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { arrDn[0] = limit+1; return(0); }
           if (TimeFrame!=Period())
           {
               int shift = -1; if (ArrowsOnFirstBar) shift=1;
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                   int y = iBarShift(NULL,TimeFrame,Time[i]);   
                   int x = iBarShift(NULL,TimeFrame,Time[i+shift]);            
                   
                  if (x!=y)
                  {
                     arrDn[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Risk,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,0,y);
                     arrUp[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Risk,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,1,y);
                  }
            }
            return(0);
            }

            //
            //
            //
            //
            //

            double x1 = 67.0+Risk;
            double x2 = 33.0-Risk;
            for (i=limit; i>=0 ; i--)
            {
               int    period = 2*Risk+3;
               double range  = 0; for (int k=0; k<10; k++) range += High[i+k]-Low[i+k]; range /= 10.0;
               bool   found1 = false; for (k=0; k<6 && !found1; k++) found1 = (MathAbs(Open[i+k] -Close[i+k+1])>=range*2.0);
               bool   found2 = false; for (k=0; k<9 && !found2; k++) found2 = (MathAbs(Close[i+k+3]-Close[i+k])>=range*4.6);
                      if (found1) period = 3;
                      if (found2) period = 4;
                           wpr[i]   = 100+iWPR(NULL,0,period,i);

               //
               //
               //
               //
               //
               
               arrDn[i] = EMPTY_VALUE;
               arrUp[i] = EMPTY_VALUE;
                   if (wpr[i] < x2) { for (k=1; i+k<Bars && wpr[i+k]>=x2 && wpr[i+k]<=x1;) k++; if (wpr[i+k]>x1) arrDn[i] = High[i]+range*ArrowsGap; }
                   if (wpr[i] > x1) { for (k=1; i+k<Bars && wpr[i+k]>=x2 && wpr[i+k]<=x1;) k++; if (wpr[i+k]<x2) arrUp[i] = Low[i] -range*ArrowsGap; }
            }
   manageAlerts();
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      if (arrDn[whichBar] != EMPTY_VALUE || arrUp[whichBar] != EMPTY_VALUE)
      {
         if (arrUp[whichBar] != EMPTY_VALUE) doAlert(whichBar,"up");
         if (arrDn[whichBar] != EMPTY_VALUE) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(timeFrameToString(_Period)," ",Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Trend Signal trend changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Trend Signal"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

